Index: drivers/filesystems/btrfs/fsctl.c
===================================================================
--- drivers/filesystems/btrfs/fsctl.c	(révision 75772)
+++ drivers/filesystems/btrfs/fsctl.c	(copie de travail)
@@ -2318,37 +2474,43 @@
     return STATUS_SUCCESS;
 }
 
+static NTSTATUS set_compression(PIRP Irp) {
+    PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
+    USHORT* compression;
+
+    TRACE("FSCTL_SET_COMPRESSION\n");
+
+    if (IrpSp->Parameters.FileSystemControl.InputBufferLength < sizeof(USHORT))
+        return STATUS_INVALID_PARAMETER;
+
+    compression = Irp->AssociatedIrp.SystemBuffer;
+
+    if (*compression != COMPRESSION_FORMAT_NONE)
+        return STATUS_INVALID_PARAMETER;
+
+    return STATUS_SUCCESS;
+}
+
 static void update_volumes(device_extension* Vcb) {
     LIST_ENTRY* le;
-    
+    volume_device_extension* vde = Vcb->vde;
+    pdo_device_extension* pdode = vde->pdode;
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-    
-    le = volumes.Flink;
-        
-    while (le != &volumes) {
-        volume* v = CONTAINING_RECORD(le, volume, list_entry);
-        
-        if (RtlCompareMemory(&Vcb->superblock.uuid, &v->fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
-            LIST_ENTRY* le;
-            
-            le = Vcb->devices.Flink;
-            while (le != &Vcb->devices) {
-                device* dev = CONTAINING_RECORD(le, device, list_entry);
-                
-                if (RtlCompareMemory(&dev->devitem.device_uuid, &v->devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
-                    v->gen1 = v->gen2 = Vcb->superblock.generation - 1;
-                    break;
-                }
-                
-                le = le->Flink;
-            }
-        }
-        
+
+    ExAcquireResourceExclusiveLite(&pdode->child_lock, TRUE);
+
+    le = pdode->children.Flink;
+    while (le != &pdode->children) {
+        volume_child* vc = CONTAINING_RECORD(le, volume_child, list_entry);
+
+        vc->generation = Vcb->superblock.generation - 1;
+
         le = le->Flink;
     }
-    
-    ExReleaseResourceLite(&volumes_lock);
+
+    ExReleaseResourceLite(&pdode->child_lock);
+
     ExReleaseResourceLite(&Vcb->tree_lock);
 }
 
@@ -2355,46 +2517,51 @@
 static NTSTATUS dismount_volume(device_extension* Vcb, PIRP Irp) {
     NTSTATUS Status;
     KIRQL irql;
-    LIST_ENTRY rollback;
-    
+
     TRACE("FSCTL_DISMOUNT_VOLUME\n");
-    
+
     if (!(Vcb->Vpb->Flags & VPB_MOUNTED))
         return STATUS_SUCCESS;
-    
+
     if (Vcb->disallow_dismount) {
         WARN("attempting to dismount boot volume or one containing a pagefile\n");
         return STATUS_ACCESS_DENIED;
     }
-    
-    InitializeListHead(&rollback);
-    
+
     Status = FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_DISMOUNT);
     if (!NT_SUCCESS(Status)) {
         WARN("FsRtlNotifyVolumeEvent returned %08x\n", Status);
     }
-    
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-    
-    flush_fcb_caches(Vcb);
-    
-    if (Vcb->need_write && !Vcb->readonly)
-        do_write(Vcb, Irp, &rollback);
-    
+
+    if (!Vcb->locked) {
+        flush_fcb_caches(Vcb);
+
+        if (Vcb->need_write && !Vcb->readonly) {
+            Status = do_write(Vcb, Irp);
+
+            if (!NT_SUCCESS(Status))
+                ERR("do_write returned %08x\n", Status);
+        }
+    }
+
     free_trees(Vcb);
-    
-    clear_rollback(Vcb, &rollback);
-    
+
     Vcb->removing = TRUE;
-    update_volumes(Vcb);
-    
+
+    if (Vcb->vde) {
+        update_volumes(Vcb);
+        Vcb->vde->mounted_device = NULL;
+    }
+
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     IoAcquireVpbSpinLock(&irql);
     Vcb->Vpb->Flags &= ~VPB_MOUNTED;
     Vcb->Vpb->Flags |= VPB_DIRECT_WRITES_ALLOWED;
     IoReleaseVpbSpinLock(irql);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -2405,15 +2572,15 @@
     UINT32 crc32;
     BTRFS_UUID fsuuid, devuuid;
     LIST_ENTRY* le;
-    
-    to_read = devobj->SectorSize == 0 ? sizeof(superblock) : sector_align(sizeof(superblock), devobj->SectorSize);
-    
+
+    to_read = devobj->SectorSize == 0 ? sizeof(superblock) : (ULONG)sector_align(sizeof(superblock), devobj->SectorSize);
+
     sb = ExAllocatePoolWithTag(PagedPool, to_read, ALLOC_TAG);
     if (!sb) {
         ERR("out of memory\n");
         return STATUS_INSUFFICIENT_RESOURCES;
     }
-    
+
     Status = sync_read_phys(devobj, superblock_addrs[0], to_read, (UINT8*)sb, TRUE);
     if (!NT_SUCCESS(Status)) {
         ERR("sync_read_phys returned %08x\n", Status);
@@ -2420,13 +2587,13 @@
         ExFreePool(sb);
         return Status;
     }
-    
+
     if (sb->magic != BTRFS_MAGIC) {
         TRACE("device is not Btrfs\n");
         ExFreePool(sb);
         return STATUS_SUCCESS;
     }
-    
+
     crc32 = ~calc_crc32c(0xffffffff, (UINT8*)&sb->uuid, (ULONG)sizeof(superblock) - sizeof(sb->checksum));
 
     if (crc32 != *((UINT32*)sb->checksum)) {
@@ -2434,80 +2601,107 @@
         ExFreePool(sb);
         return STATUS_SUCCESS;
     }
-    
+
     fsuuid = sb->uuid;
     devuuid = sb->dev_item.device_uuid;
-    
+
     ExFreePool(sb);
-    
+
     ExAcquireResourceSharedLite(&global_loading_lock, TRUE);
-    
+
     le = VcbList.Flink;
-    
+
     while (le != &VcbList) {
         device_extension* Vcb = CONTAINING_RECORD(le, device_extension, list_entry);
-        
+
         if (RtlCompareMemory(&Vcb->superblock.uuid, &fsuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
             LIST_ENTRY* le2;
-            
+
             ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
-            
+
             if (Vcb->superblock.num_devices > 1) {
                 le2 = Vcb->devices.Flink;
                 while (le2 != &Vcb->devices) {
                     device* dev = CONTAINING_RECORD(le2, device, list_entry);
-                    
+
                     if (RtlCompareMemory(&dev->devitem.device_uuid, &devuuid, sizeof(BTRFS_UUID)) == sizeof(BTRFS_UUID)) {
                         ExReleaseResourceLite(&Vcb->tree_lock);
                         ExReleaseResourceLite(&global_loading_lock);
                         return STATUS_DEVICE_NOT_READY;
                     }
-                    
+
                     le2 = le2->Flink;
                 }
             }
-            
+
             ExReleaseResourceLite(&Vcb->tree_lock);
             ExReleaseResourceLite(&global_loading_lock);
             return STATUS_SUCCESS;
         }
-        
+
         le = le->Flink;
     }
-    
+
     ExReleaseResourceLite(&global_loading_lock);
-    
+
     return STATUS_SUCCESS;
 }
 
-static NTSTATUS add_device(device_extension* Vcb, PIRP Irp, void* data, ULONG length, KPROCESSOR_MODE processor_mode) {
+void trim_whole_device(device* dev) {
+    DEVICE_MANAGE_DATA_SET_ATTRIBUTES dmdsa;
+    NTSTATUS Status;
+
+    // FIXME - avoid "bootloader area"??
+
+    dmdsa.Size = sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES);
+    dmdsa.Action = DeviceDsmAction_Trim;
+    dmdsa.Flags = DEVICE_DSM_FLAG_ENTIRE_DATA_SET_RANGE | DEVICE_DSM_FLAG_TRIM_NOT_FS_ALLOCATED;
+    dmdsa.ParameterBlockOffset = 0;
+    dmdsa.ParameterBlockLength = 0;
+    dmdsa.DataSetRangesOffset = 0;
+    dmdsa.DataSetRangesLength = 0;
+
+    Status = dev_ioctl(dev->devobj, IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES, &dmdsa, sizeof(DEVICE_MANAGE_DATA_SET_ATTRIBUTES), NULL, 0, TRUE, NULL);
+    if (!NT_SUCCESS(Status))
+        WARN("IOCTL_STORAGE_MANAGE_DATA_SET_ATTRIBUTES returned %08x\n", Status);
+}
+
+static NTSTATUS add_device(device_extension* Vcb, PIRP Irp, KPROCESSOR_MODE processor_mode) {
     PIO_STACK_LOCATION IrpSp = IoGetCurrentIrpStackLocation(Irp);
     NTSTATUS Status;
     PFILE_OBJECT fileobj, mountmgrfo;
+    PDEVICE_OBJECT DeviceObject;
     HANDLE h;
-    LIST_ENTRY rollback, *le;
-    GET_LENGTH_INFORMATION gli;
+    LIST_ENTRY* le;
     device* dev;
     DEV_ITEM* di;
-    UINT64 dev_id;
+    UINT64 dev_id, size;
     UINT8* mb;
     UINT64* stats;
-    MOUNTDEV_NAME mdn1, *mdn2;
-    UNICODE_STRING volname, mmdevpath;
-    volume* v;
+    UNICODE_STRING mmdevpath, pnp_name, pnp_name2;
+    volume_child* vc;
     PDEVICE_OBJECT mountmgr;
     KEY searchkey;
     traverse_ptr tp;
     STORAGE_DEVICE_NUMBER sdn;
-    
-    volname.Buffer = NULL;
-    
+    volume_device_extension* vde;
+    pdo_device_extension* pdode;
+    const GUID* pnp_guid;
+    GET_LENGTH_INFORMATION gli;
+
+    pnp_name.Buffer = NULL;
+
     if (!SeSinglePrivilegeCheck(RtlConvertLongToLuid(SE_MANAGE_VOLUME_PRIVILEGE), processor_mode))
         return STATUS_PRIVILEGE_NOT_HELD;
-    
+
+    if (!Vcb->vde) {
+        WARN("not allowing second device to be added to non-PNP device\n");
+        return STATUS_NOT_SUPPORTED;
+    }
+
     if (Vcb->readonly) // FIXME - handle adding R/W device to seeding device
         return STATUS_MEDIA_WRITE_PROTECTED;
-    
+
 #if defined(_WIN64)
     if (IoIs32bitProcess(Irp)) {
         if (IrpSp->Parameters.FileSystemControl.InputBufferLength != sizeof(UINT32))
@@ -2530,104 +2724,112 @@
         ERR("ObReferenceObjectByHandle returned %08x\n", Status);
         return Status;
     }
-    
-    Status = is_device_part_of_mounted_btrfs_raid(fileobj->DeviceObject);
+
+    DeviceObject = fileobj->DeviceObject;
+
+    Status = get_device_pnp_name(DeviceObject, &pnp_name, &pnp_guid);
     if (!NT_SUCCESS(Status)) {
-        ERR("is_device_part_of_mounted_btrfs_raid returned %08x\n", Status);
+        ERR("get_device_pnp_name returned %08x\n", Status);
         ObDereferenceObject(fileobj);
         return Status;
     }
-    
-    Status = dev_ioctl(fileobj->DeviceObject, IOCTL_DISK_IS_WRITABLE, NULL, 0, NULL, 0, TRUE, NULL);
+
+    // If this is a disk, we have been handed the PDO, so need to go up to find something we can use
+    if (RtlCompareMemory(pnp_guid, &GUID_DEVINTERFACE_DISK, sizeof(GUID)) == sizeof(GUID) && DeviceObject->AttachedDevice)
+        DeviceObject = DeviceObject->AttachedDevice;
+
+    Status = dev_ioctl(DeviceObject, IOCTL_DISK_IS_WRITABLE, NULL, 0, NULL, 0, TRUE, NULL);
     if (!NT_SUCCESS(Status)) {
         ERR("IOCTL_DISK_IS_WRITABLE returned %08x\n", Status);
         ObDereferenceObject(fileobj);
         return Status;
     }
-    
-    Status = dev_ioctl(fileobj->DeviceObject, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
-                       &gli, sizeof(gli), TRUE, NULL);
+
+    Status = is_device_part_of_mounted_btrfs_raid(DeviceObject);
     if (!NT_SUCCESS(Status)) {
-        ERR("error reading length information: %08x\n", Status);
+        ERR("is_device_part_of_mounted_btrfs_raid returned %08x\n", Status);
         ObDereferenceObject(fileobj);
         return Status;
     }
-    
-    if (gli.Length.QuadPart < 0x100000) {
-        ERR("device was not large enough to hold FS (%llx bytes, need at least 1 MB)\n", gli.Length.QuadPart);
-        ObDereferenceObject(fileobj);
-        return STATUS_INTERNAL_ERROR;
+
+    // if disk, check it has no partitions
+    if (RtlCompareMemory(pnp_guid, &GUID_DEVINTERFACE_DISK, sizeof(GUID)) == sizeof(GUID)) {
+        ULONG dlisize;
+        DRIVE_LAYOUT_INFORMATION_EX* dli = NULL;
+
+        dlisize = 0;
+
+        do {
+            dlisize += 1024;
+
+            if (dli)
+                ExFreePool(dli);
+
+            dli = ExAllocatePoolWithTag(PagedPool, dlisize, ALLOC_TAG);
+            if (!dli) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end2;
+            }
+
+            Status = dev_ioctl(DeviceObject, IOCTL_DISK_GET_DRIVE_LAYOUT_EX, NULL, 0, dli, dlisize, TRUE, NULL);
+        } while (Status == STATUS_BUFFER_TOO_SMALL);
+
+        if (NT_SUCCESS(Status) && dli->PartitionCount > 0) {
+            ExFreePool(dli);
+            ERR("not adding disk which has partitions\n");
+            Status = STATUS_DEVICE_NOT_READY;
+            goto end2;
+        }
+
+        ExFreePool(dli);
     }
-    
-    Status = dev_ioctl(fileobj->DeviceObject, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0,
-                       &mdn1, sizeof(MOUNTDEV_NAME), TRUE, NULL);
-    if (Status == STATUS_BUFFER_OVERFLOW) {
-        mdn2 = ExAllocatePoolWithTag(PagedPool, offsetof(MOUNTDEV_NAME, Name[0]) + mdn1.NameLength, ALLOC_TAG);
-        if (!mdn2) {
-            ERR("out of memory\n");
+
+    Status = dev_ioctl(DeviceObject, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
+                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
+    if (NT_SUCCESS(Status)) {
+        if (sdn.DeviceType != FILE_DEVICE_DISK) { // FIXME - accept floppies and CDs?
+            WARN("device was not disk\n");
             ObDereferenceObject(fileobj);
-            return STATUS_INTERNAL_ERROR;
+            return STATUS_INVALID_PARAMETER;
         }
-        
-        Status = dev_ioctl(fileobj->DeviceObject, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, NULL, 0,
-                           mdn2, offsetof(MOUNTDEV_NAME, Name[0]) + mdn1.NameLength, TRUE, NULL);
-        
-        if (!NT_SUCCESS(Status)) {
-            ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
-            ObDereferenceObject(fileobj);
-            return Status;
-        }
-    } else if (NT_SUCCESS(Status)) {
-        mdn2 = ExAllocatePoolWithTag(PagedPool, sizeof(MOUNTDEV_NAME), ALLOC_TAG);
-        if (!mdn2) {
-            ERR("out of memory\n");
-            ObDereferenceObject(fileobj);
-            return STATUS_INTERNAL_ERROR;
-        }
-        
-        RtlCopyMemory(mdn2, &mdn1, sizeof(MOUNTDEV_NAME));
     } else {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned %08x\n", Status);
+        sdn.DeviceNumber = 0xffffffff;
+        sdn.PartitionNumber = 0xffffffff;
+    }
+
+    Status = dev_ioctl(DeviceObject, IOCTL_DISK_GET_LENGTH_INFO, NULL, 0,
+                        &gli, sizeof(gli), TRUE, NULL);
+    if (!NT_SUCCESS(Status)) {
+        ERR("error reading length information: %08x\n", Status);
         ObDereferenceObject(fileobj);
         return Status;
     }
-    
-    if (mdn2->NameLength == 0) {
-        ERR("IOCTL_MOUNTDEV_QUERY_DEVICE_NAME returned zero-length name\n");
+
+    size = gli.Length.QuadPart;
+
+    if (size < 0x100000) {
+        ERR("device was not large enough to hold FS (%llx bytes, need at least 1 MB)\n", size);
         ObDereferenceObject(fileobj);
-        ExFreePool(mdn2);
         return STATUS_INTERNAL_ERROR;
     }
-    
-    volname.Length = volname.MaximumLength = mdn2->NameLength;
-    volname.Buffer = ExAllocatePoolWithTag(PagedPool, volname.MaximumLength, ALLOC_TAG);
-    if (!volname.Buffer) {
-        ERR("out of memory\n");
-        ObDereferenceObject(fileobj);
-        ExFreePool(mdn2);
-        return STATUS_INSUFFICIENT_RESOURCES;
-    }
-    
-    RtlCopyMemory(volname.Buffer, mdn2->Name, volname.Length);
-    ExFreePool(mdn2);
-    
-    InitializeListHead(&rollback);
-    
+
+    volume_removal(drvobj, &pnp_name);
+
     ExAcquireResourceExclusiveLite(&Vcb->tree_lock, TRUE);
-        
-    if (Vcb->need_write) {
-        Status = do_write(Vcb, Irp, &rollback);
-        if (!NT_SUCCESS(Status)) {
-            ERR("do_write returned %08x\n", Status);
-            do_rollback(Vcb, &rollback);
-            goto end;
-        }
+
+    if (Vcb->need_write)
+        Status = do_write(Vcb, Irp);
+    else
+        Status = STATUS_SUCCESS;
+
+    free_trees(Vcb);
+
+    if (!NT_SUCCESS(Status)) {
+        ERR("do_write returned %08x\n", Status);
+        goto end;
     }
-    
-    free_trees(Vcb);
-    
-    clear_rollback(Vcb, &rollback);
-    
+
     dev = ExAllocatePoolWithTag(NonPagedPool, sizeof(device), ALLOC_TAG);
     if (!dev) {
         ERR("out of memory\n");
@@ -2634,41 +2836,39 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     RtlZeroMemory(dev, sizeof(device));
 
-    dev->devobj = fileobj->DeviceObject;
+    dev->devobj = DeviceObject;
     dev->seeding = FALSE;
-    dev->length = gli.Length.QuadPart;
-    init_device(Vcb, dev, FALSE, TRUE);
-    
+    init_device(Vcb, dev, TRUE);
+
     InitializeListHead(&dev->space);
-    
-    if (gli.Length.QuadPart > 0x100000) { // add disk hole - the first MB is marked as used
-        Status = add_space_entry(&dev->space, NULL, 0x100000, gli.Length.QuadPart - 0x100000);
+
+    if (size > 0x100000) { // add disk hole - the first MB is marked as used
+        Status = add_space_entry(&dev->space, NULL, 0x100000, size - 0x100000);
         if (!NT_SUCCESS(Status)) {
             ERR("add_space_entry returned %08x\n", Status);
-            Status = STATUS_INTERNAL_ERROR;
             goto end;
         }
     }
-    
+
     dev_id = 0;
-    
+
     le = Vcb->devices.Flink;
     while (le != &Vcb->devices) {
-        device* dev = CONTAINING_RECORD(le, device, list_entry);
-        
-        if (dev->devitem.dev_id > dev_id)
-            dev_id = dev->devitem.dev_id;
-        
+        device* dev2 = CONTAINING_RECORD(le, device, list_entry);
+
+        if (dev2->devitem.dev_id > dev_id)
+            dev_id = dev2->devitem.dev_id;
+
         le = le->Flink;
     }
-    
+
     dev_id++;
-    
+
     dev->devitem.dev_id = dev_id;
-    dev->devitem.num_bytes = gli.Length.QuadPart;
+    dev->devitem.num_bytes = size;
     dev->devitem.bytes_used = 0;
     dev->devitem.optimal_io_align = Vcb->superblock.sector_size;
     dev->devitem.optimal_io_width = Vcb->superblock.sector_size;
@@ -2681,52 +2881,62 @@
     dev->devitem.bandwidth = 0;
     get_uuid(&dev->devitem.device_uuid);
     dev->devitem.fs_uuid = Vcb->superblock.uuid;
-    
+
     di = ExAllocatePoolWithTag(PagedPool, sizeof(DEV_ITEM), ALLOC_TAG);
     if (!di) {
         ERR("out of memory\n");
         goto end;
     }
-    
+
     RtlCopyMemory(di, &dev->devitem, sizeof(DEV_ITEM));
-    
-    if (!insert_tree_item(Vcb, Vcb->chunk_root, 1, TYPE_DEV_ITEM, di->dev_id, di, sizeof(DEV_ITEM), NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
+
+    Status = insert_tree_item(Vcb, Vcb->chunk_root, 1, TYPE_DEV_ITEM, di->dev_id, di, sizeof(DEV_ITEM), NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(di);
-        Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
-    
+
     // add stats entry to dev tree
     stats = ExAllocatePoolWithTag(PagedPool, sizeof(UINT64) * 5, ALLOC_TAG);
     if (!stats) {
         ERR("out of memory\n");
-        Status = STATUS_INTERNAL_ERROR;
+        Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     RtlZeroMemory(stats, sizeof(UINT64) * 5);
-    
+
     searchkey.obj_id = 0;
     searchkey.obj_type = TYPE_DEV_STATS;
     searchkey.offset = di->dev_id;
-    
+
     Status = find_item(Vcb, Vcb->dev_root, &tp, &searchkey, FALSE, Irp);
     if (!NT_SUCCESS(Status)) {
         ERR("error - find_item returned %08x\n", Status);
+        ExFreePool(stats);
         goto end;
     }
-    
-    if (!keycmp(tp.item->key, searchkey))
-        delete_tree_item(Vcb, &tp, &rollback);
-    
-    if (!insert_tree_item(Vcb, Vcb->dev_root, 0, TYPE_DEV_STATS, di->dev_id, stats, sizeof(UINT64) * 5, NULL, Irp, &rollback)) {
-        ERR("insert_tree_item failed\n");
+
+    if (!keycmp(tp.item->key, searchkey)) {
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            ExFreePool(stats);
+            goto end;
+        }
+    }
+
+    Status = insert_tree_item(Vcb, Vcb->dev_root, 0, TYPE_DEV_STATS, di->dev_id, stats, sizeof(UINT64) * 5, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
         ExFreePool(stats);
-        Status = STATUS_INTERNAL_ERROR;
         goto end;
     }
-    
+
+    if (dev->trim && !dev->readonly && !Vcb->options.no_trim)
+        trim_whole_device(dev);
+
     // We clear the first megabyte of the device, so Windows doesn't identify it as another FS
     mb = ExAllocatePoolWithTag(PagedPool, 0x100000, ALLOC_TAG);
     if (!mb) {
@@ -2734,82 +2944,119 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     RtlZeroMemory(mb, 0x100000);
-    
-    Status = write_data_phys(fileobj->DeviceObject, 0, mb, 0x100000);
+
+    Status = write_data_phys(DeviceObject, 0, mb, 0x100000);
     if (!NT_SUCCESS(Status)) {
         ERR("write_data_phys returned %08x\n", Status);
+        ExFreePool(mb);
         goto end;
     }
-    
+
     ExFreePool(mb);
-    
-    v = ExAllocatePoolWithTag(PagedPool, sizeof(volume), ALLOC_TAG);
-    if (!v) {
+
+    vde = Vcb->vde;
+    pdode = vde->pdode;
+
+    vc = ExAllocatePoolWithTag(NonPagedPool, sizeof(volume_child), ALLOC_TAG);
+    if (!vc) {
         ERR("out of memory\n");
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
-    v->fsuuid = Vcb->superblock.uuid;
-    v->devuuid = dev->devitem.device_uuid;
-    v->devnum = dev_id;
-    v->devpath = volname;
-    v->length = gli.Length.QuadPart;
-    v->gen1 = v->gen2 = Vcb->superblock.generation;
-    v->seeding = FALSE;
-    v->processed = TRUE;
-    
-    ExAcquireResourceExclusiveLite(&volumes_lock, TRUE);
-    InsertTailList(&volumes, &v->list_entry);
-    ExReleaseResourceLite(&volumes_lock);
-    
-    volname.Buffer = NULL;
-    
-    Status = dev_ioctl(fileobj->DeviceObject, IOCTL_STORAGE_GET_DEVICE_NUMBER, NULL, 0,
-                       &sdn, sizeof(STORAGE_DEVICE_NUMBER), TRUE, NULL);
-    if (!NT_SUCCESS(Status)) {
-        WARN("IOCTL_STORAGE_GET_DEVICE_NUMBER returned %08x\n", Status);
-        v->disk_num = 0;
-        v->part_num = 0;
-    } else {
-        v->disk_num = sdn.DeviceNumber;
-        v->part_num = sdn.PartitionNumber;
+
+    vc->uuid = dev->devitem.device_uuid;
+    vc->devid = dev_id;
+    vc->generation = Vcb->superblock.generation;
+    vc->devobj = DeviceObject;
+    vc->fileobj = fileobj;
+    vc->notification_entry = NULL;
+
+    Status = IoRegisterPlugPlayNotification(EventCategoryTargetDeviceChange, 0, fileobj,
+                                            drvobj, pnp_removal, vde->pdode, &vc->notification_entry);
+    if (!NT_SUCCESS(Status))
+        WARN("IoRegisterPlugPlayNotification returned %08x\n", Status);
+
+    pnp_name2 = pnp_name;
+
+    if (pnp_name.Length > 4 * sizeof(WCHAR) && pnp_name.Buffer[0] == '\\' && (pnp_name.Buffer[1] == '\\' || pnp_name.Buffer[1] == '?') &&
+        pnp_name.Buffer[2] == '?' && pnp_name.Buffer[3] == '\\') {
+        pnp_name2.Buffer = &pnp_name2.Buffer[3];
+        pnp_name2.Length -= 3 * sizeof(WCHAR);
+        pnp_name2.MaximumLength -= 3 * sizeof(WCHAR);
     }
-    
+
+    vc->pnp_name.Length = vc->pnp_name.MaximumLength = pnp_name2.Length;
+
+    if (pnp_name2.Length == 0)
+        vc->pnp_name.Buffer = NULL;
+    else {
+        vc->pnp_name.Buffer = ExAllocatePoolWithTag(PagedPool, pnp_name2.Length, ALLOC_TAG);
+        if (!vc->pnp_name.Buffer) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
+        }
+
+        RtlCopyMemory(vc->pnp_name.Buffer, pnp_name2.Buffer, pnp_name2.Length);
+    }
+
+    vc->size = size;
+    vc->seeding = FALSE;
+    vc->disk_num = sdn.DeviceNumber;
+    vc->part_num = sdn.PartitionNumber;
+    vc->had_drive_letter = FALSE;
+
+    ExAcquireResourceExclusiveLite(&pdode->child_lock, TRUE);
+    InsertTailList(&pdode->children, &vc->list_entry);
+    pdode->num_children++;
+    pdode->children_loaded++;
+    ExReleaseResourceLite(&pdode->child_lock);
+
     RtlInitUnicodeString(&mmdevpath, MOUNTMGR_DEVICE_NAME);
     Status = IoGetDeviceObjectPointer(&mmdevpath, FILE_READ_ATTRIBUTES, &mountmgrfo, &mountmgr);
     if (!NT_SUCCESS(Status))
         ERR("IoGetDeviceObjectPointer returned %08x\n", Status);
     else {
-        remove_drive_letter(mountmgr, v);
-        
+        Status = remove_drive_letter(mountmgr, &pnp_name);
+        if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND)
+            WARN("remove_drive_letter returned %08x\n", Status);
+
+        vc->had_drive_letter = NT_SUCCESS(Status);
+
         ObDereferenceObject(mountmgrfo);
     }
-    
+
     Vcb->superblock.num_devices++;
-    Vcb->superblock.total_bytes += gli.Length.QuadPart;
+    Vcb->superblock.total_bytes += size;
     Vcb->devices_loaded++;
     InsertTailList(&Vcb->devices, &dev->list_entry);
-    
-    ObReferenceObject(fileobj->DeviceObject);
-    
-    do_write(Vcb, Irp, &rollback);
 
+    // FIXME - send notification that volume size has increased
+
+    ObReferenceObject(DeviceObject); // for Vcb
+
+    Status = do_write(Vcb, Irp);
+    if (!NT_SUCCESS(Status))
+        ERR("do_write returned %08x\n", Status);
+
+    ObReferenceObject(fileobj);
+
+end:
     free_trees(Vcb);
-    
-    clear_rollback(Vcb, &rollback);
-    
-    Status = STATUS_SUCCESS;
-    
-end:
+
     ExReleaseResourceLite(&Vcb->tree_lock);
+
+end2:
     ObDereferenceObject(fileobj);
-    
-    if (volname.Buffer)
-        ExFreePool(volname.Buffer);
-    
+
+    if (pnp_name.Buffer)
+        ExFreePool(pnp_name.Buffer);
+
+    if (NT_SUCCESS(Status))
+        FsRtlNotifyVolumeEvent(Vcb->root_file, FSRTL_VOLUME_CHANGE_SIZE);
+
     return Status;
 }
 
@@ -2816,26 +3063,26 @@
 static NTSTATUS allow_extended_dasd_io(device_extension* Vcb, PFILE_OBJECT FileObject) {
     fcb* fcb;
     ccb* ccb;
-    
+
     TRACE("FSCTL_ALLOW_EXTENDED_DASD_IO\n");
-    
+
     if (!FileObject)
         return STATUS_INVALID_PARAMETER;
-    
+
     fcb = FileObject->FsContext;
     ccb = FileObject->FsContext2;
-    
+
     if (!fcb)
         return STATUS_INVALID_PARAMETER;
-    
+
     if (fcb != Vcb->volume_fcb)
         return STATUS_INVALID_PARAMETER;
-    
+
     if (!ccb)
         return STATUS_INVALID_PARAMETER;
-    
+
     ccb->allow_extended_dasd_io = TRUE;
-    
+
     return STATUS_SUCCESS;
 }
 
